#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

#include <Python.h>

static PyObject *winmain_func;

static void python_init_module(char *name)
{
    PyObject *obj = NULL, *mod = NULL, *dict = NULL;

    Py_Initialize();

    obj = PyString_FromString(name);
    if (obj != NULL) {
	mod = PyImport_Import(obj);
	if (PyErr_Occurred())
	    mod = NULL;
    }
    if (mod != NULL)
	dict = PyModule_GetDict(mod);
    if (dict != NULL)
	winmain_func = PyDict_GetItemString(dict, "winmain");

    Py_XDECREF(obj);
    Py_XDECREF(mod);
    Py_XDECREF(dict);
}

int APIENTRY WinMain(HINSTANCE inst, HINSTANCE prev_inst, LPSTR cmd_line, int cmd_show)
{
    PyObject *obj;
    int ret;

    python_init_module(cmd_line);
    if (winmain_func == NULL)
	return 0;

    ret = 0;
    obj = PyObject_CallFunction(winmain_func, "iisi", inst, prev_inst, cmd_line, cmd_show);
    if (obj != NULL)
	ret = PyInt_AsLong(obj);
    Py_XDECREF(obj);
    return ret;
}
