from sdk32 import *
import os

MAXENV = 4096
wnd_list = wnd_text = 0
tm = TEXTMETRIC()
buff = Buffer()

def wnd_proc(wnd, msg, wparam, lparam):
    global wnd_list, wnd_text, tm
    if msg == WM_CREATE:
        dc = GetDC(wnd)
        GetTextMetrics(dc, tm)
        ReleaseDC(wnd, dc)

        wnd_list = CreateWindow('listbox', None,
                                WS_CHILD | WS_VISIBLE | LBS_STANDARD,
                                tm.ave_char_width, tm.height * 3,
                                tm.ave_char_width * 16 + GetSystemMetrics(SM_CXVSCROLL),
                                tm.height * 5, wnd, 1,
                                GetWindowLong(wnd, GWL_HINSTANCE), None)
        wnd_text = CreateWindow('static', None,
                                WS_CHILD | WS_VISIBLE | SS_LEFT,
                                tm.ave_char_width, tm.height,
                                tm.ave_char_width * MAXENV, tm.height,
                                wnd, 2,
                                GetWindowLong(wnd, GWL_HINSTANCE), None)
        names = os.environ.keys()
        names.sort()
        for name in names:
            SendMessage(wnd_list, LB_ADDSTRING, 0, string_to_ptr(name))
        return 0

    elif msg == WM_SETFOCUS:
        SetFocus(wnd_list)
        return 0

    elif msg == WM_COMMAND:
        if LOWORD(wparam) == 1 and HIWORD(wparam) == LBN_SELCHANGE:
            n = SendMessage(wnd_list, LB_GETCURSEL, 0, 0)
            l = SendMessage(wnd_list, LB_GETTEXTLEN, n, 0)
            buffer_ensure_size(buff, l + 1)
            ptr = buffer_get_ptr(buff)
            n = SendMessage(wnd_list, LB_GETTEXT, n, ptr)
            name = string_from_ptr(ptr)
            SetWindowText(wnd_text, '%s=%s' % (name, os.environ[name]))
        return 0

    elif msg == WM_DESTROY:
        PostQuitMessage(0)
        return 0

    return DefWindowProc(wnd, msg, wparam, lparam)

def winmain(inst, prev_inst, cmd_line, cmd_show):
    app_name = 'Environ'

    wc = WNDCLASSEX()
    wc.style = CS_HREDRAW | CS_VREDRAW
    wc.wnd_proc = wnd_proc
    wc.inst = inst
    wc.cursor = LoadCursor(0, IDC_ARROW)
    wc.background = COLOR_WINDOW + 1
    wc.name = app_name
    RegisterClassEx(wc)

    wnd = CreateWindow(app_name, 'Environment List Box', WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT, CW_USEDEFAULT,
                       CW_USEDEFAULT, CW_USEDEFAULT, 0, 0, inst, 0)

    ShowWindow(wnd, cmd_show)
    UpdateWindow(wnd)

    msg = MSG()
    while 1:
        if not GetMessage(msg, 0, 0, 0):
            break
        TranslateMessage(msg)
        DispatchMessage(msg)
    return msg.wparam

if __name__ == '__main__':
    winmain(GetModuleHandle(None), 0, '', SW_SHOWNORMAL)
